/*
 * ExactTreePatternAutomaton.h
 *
 *  Created on: 7. 4. 2015
 *      Author: Jan Travnicek
 */

#ifndef _EXACT_TREE_PATTERN_AUTOMATON_H__
#define _EXACT_TREE_PATTERN_AUTOMATON_H__

#include <automaton/AutomatonFeatures.h>
#include <tree/TreeFeatures.h>
#include <core/multipleDispatch.hpp>
#include <alphabet/Symbol.h>

namespace arbology {

namespace exact {

class ExactTreePatternAutomaton : public std::SingleDispatch < ExactTreePatternAutomaton, automaton::Automaton, const tree::TreeBase &, const alphabet::Symbol & > {
public:
	/**
	 * Performs conversion.
	 * @return left regular grammar equivalent to source automaton.
	 */
	static automaton::Automaton construct ( const tree::Tree & tree, const alphabet::Symbol & subtreeWildcard );

	static automaton::InputDrivenNPDA < > construct ( const tree::PrefixRankedTree & tree, const alphabet::Symbol & subtreeWildcard );

};

} /* namespace exact */

} /* namespace arbology */

#endif /* _EXACT_TREE_PATTERN_AUTOMATON_H__ */
