/*
 * BeginToEndIndex.h
 *
 *  Created on: 5. 11. 2014
 *      Author: Jan Travnicek
 */

#ifndef _ARBOLOGY_BEGIN_TO_END_INDEX_H_
#define _ARBOLOGY_BEGIN_TO_END_INDEX_H_

#include <set>
#include <core/multipleDispatch.hpp>
#include <tree/TreeFeatures.h>

namespace arbology {

namespace transform {

/**
 */
class BeginToEndIndex : public std::SingleDispatch < BeginToEndIndex, std::set < unsigned >, const tree::TreeBase &, const std::set < unsigned > & > {
public:
	/**
	 * Search for pattern in linear string.
	 * @return set set of occurences
	 */
	static std::set < unsigned > transform ( const tree::Tree & subject, const std::set < unsigned > & indexes );

	static std::set < unsigned > transform ( const tree::PrefixRankedBarTree & subject, const std::set < unsigned > & indexes );
	static std::set < unsigned > transform ( const tree::PrefixRankedTree & subject, const std::set < unsigned > & indexes );

};

} /* namespace transform */

} /* namespace arbology */

#endif /* _ARBOLOGY_BEGIN_TO_END_INDEX_H_ */
