/*
 * CompactNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "CompactNFA.h"
#include "../Automaton.h"
#include <object/Object.h>
#include <XmlApi.hpp>

#include <cast/CastApi.hpp>

namespace automaton {

} /* namespace automaton */

namespace alib {

auto compactNFAParserRegister = xmlApi < automaton::Automaton >::ParserRegister < automaton::CompactNFA < > > ( );
auto compactNFAParserRegister2 = xmlApi < alib::Object >::ParserRegister < automaton::CompactNFA < > > ( );

auto CompactNFAFromDFA = castApi::CastRegister < automaton::CompactNFA < >, automaton::DFA < > > ( );
auto CompactNFAFromNFA = castApi::CastRegister < automaton::CompactNFA < >, automaton::NFA < > > ( );
auto CompactNFAFromMultiInitialStateNFA = castApi::CastRegister < automaton::CompactNFA < >, automaton::MultiInitialStateNFA < > > ( );
auto CompactNFAEpsilonNFA = castApi::CastRegister < automaton::CompactNFA < >, automaton::EpsilonNFA < > > ( );
auto CompactNFACastBinder = castApi::CastPoolStringBinder < automaton::CompactNFA < > > ( automaton::CompactNFA < >::getXmlTagName() );

} /* namespace alib */
