/*
 * FinalStateLabel.cpp
 *
 *  Created on: Mar 26, 2013
 *      Author: Jan Travicek
 */

#include "FinalStateLabel.h"
#include <sax/FromXMLParserHelper.h>
#include "Label.h"
#include <object/Object.h>
#include <XmlApi.hpp>
#include "UniqueLabel.h"

namespace label {

FinalStateLabel::FinalStateLabel() {

}

LabelBase* FinalStateLabel::clone() const {
	return new FinalStateLabel(*this);
}

LabelBase* FinalStateLabel::plunder() && {
	return new FinalStateLabel(std::move(*this));
}

int FinalStateLabel::compare(const FinalStateLabel&) const {
	return 0;
}

void FinalStateLabel::operator>>(std::ostream& out) const {
	out << "(FinalStateLabel)";
}

FinalStateLabel::operator std::string() const {
	return "f";
}

FinalStateLabel FinalStateLabel::FINAL_STATE = FinalStateLabel ( );
Label FinalStateLabel::FINAL_STATE_LABEL = Label ( FinalStateLabel ( ) );

FinalStateLabel FinalStateLabel::parse(std::deque<sax::Token>::iterator& input) {
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::START_ELEMENT, FinalStateLabel::getXmlTagName());
	sax::FromXMLParserHelper::popToken(input, sax::Token::TokenType::END_ELEMENT, FinalStateLabel::getXmlTagName());
	return FinalStateLabel();
}

void FinalStateLabel::compose(std::deque<sax::Token>& out) const {
	out.emplace_back(FinalStateLabel::getXmlTagName(), sax::Token::TokenType::START_ELEMENT);
	out.emplace_back(FinalStateLabel::getXmlTagName(), sax::Token::TokenType::END_ELEMENT);
}

LabelBase* FinalStateLabel::next() const {
	return new UniqueLabel(Label(*this), primitive::Integer(0));
}

LabelBase* FinalStateLabel::inc() && {
	return new UniqueLabel(Label(std::move(*this)), primitive::Integer(0));
}

} /* namespace label */

namespace alib {

auto finalStateLabelParserRegister = xmlApi<label::Label>::ParserRegister<label::FinalStateLabel>();
auto finalStateLabelParserRegister2 = xmlApi<alib::Object>::ParserRegister<label::FinalStateLabel>();

} /* namespace alib */
