#ifndef RTE_H_
#define RTE_H_

#include "RTEBase.h"
#include <base/WrapperBase.hpp>

#include "../alphabet/SymbolFeatures.h"
#include "../string/StringFeatures.h"
#include <set>
#include <string>

namespace rte {

/**
 * Wrapper around automata.
 */
class RTE : public alib::WrapperBase < RTEBase > {
	using alib::WrapperBase < RTEBase >::WrapperBase;

public:
	const std::set < alphabet::RankedSymbol > & getAlphabet ( ) const;
	const std::set < alphabet::RankedSymbol > & getSubstitutionAlphabet ( ) const;

	static const std::string & getXmlTagRefName ( ) {
		static std::string xmlTagName = "RTERef";

		return xmlTagName;
	}

};

} /* namespace rte */

namespace std {

template < >
struct compare < rte::RTE > {
	int operator ()( const rte::RTE & first, const rte::RTE & second ) const {
		return first.getData ( ).compare ( second.getData ( ) );
	}

};

} /* namespace std */

#endif /* RTE_H_ */
