#ifndef FORMAL_RTE_SYMBOL_H_
#define FORMAL_RTE_SYMBOL_H_

#include "../../alphabet/RankedSymbol.h"
#include "FormalRTEElement.h"

namespace rte {

/**
 * Represents symbol, abstract class
 */
class FormalRTESymbol : public FormalRTEElement {
protected:
	alphabet::RankedSymbol symbol;

public:
	FormalRTESymbol ( alphabet::RankedSymbol symbol );

	/**
	 * @copydoc FormalRTEElement::clone() const
	 */
	virtual FormalRTESymbol * clone ( ) const = 0;

	/**
	 * @copydoc FormalRTEElement::plunder() const
	 */
	virtual FormalRTESymbol * plunder ( ) && = 0;

	alphabet::RankedSymbol getSymbol ( ) const;
};

} /* namespace rte */

#endif /* FORMAL_RTE_SYMBOL_H_ */
