#include "FormalRTESymbolSubst.h"

#include <primitive/Unsigned.h>
#include <exception/CommonException.h>
#include <exception/CommonException.h>
#include <sstream>

namespace rte {

FormalRTESymbolSubst::FormalRTESymbolSubst ( alphabet::RankedSymbol symbol ) : FormalRTESymbol ( symbol ) {
}

FormalRTESymbolSubst * FormalRTESymbolSubst::clone ( ) const {
	return new FormalRTESymbolSubst ( * this );
}

FormalRTESymbolSubst * FormalRTESymbolSubst::plunder ( ) && {
	return new FormalRTESymbolSubst ( std::move ( * this ) );
}

int FormalRTESymbolSubst::compare ( const FormalRTESymbolSubst & other ) const {
	std::compare < decltype ( symbol ) > comp;

	return comp ( symbol, other.symbol );
}

void FormalRTESymbolSubst::operator >>( std::ostream & out ) const {
	out << "(FormalRTESymbolSubst " << " symbol = " << this->symbol << "})";
}

bool FormalRTESymbolSubst::testSymbol ( const alphabet::RankedSymbol & symbol ) const {
	return symbol == this->symbol;
}

void FormalRTESymbolSubst::computeMinimalAlphabet ( std::set < alphabet::RankedSymbol > & /* alphabetF */, std::set < alphabet::RankedSymbol > & alphabetK ) const {
	alphabetK.insert ( this->symbol );
}

bool FormalRTESymbolSubst::checkAlphabet ( const std::set < alphabet::RankedSymbol > & /* alphabetF */, const std::set < alphabet::RankedSymbol > & alphabetK ) const {
	return alphabetK.count ( getSymbol ( ) ) > 0;
}

FormalRTESymbolSubst::operator std::string ( ) const {
	std::stringstream ss;
	ss << * this;
	return ss.str ( );
}

} /* namespace rte */
