/*
 * String.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "String.h"
#include "LinearString.h"
#include "CyclicString.h"
#include "Epsilon.h"
#include <XmlApi.hpp>

namespace string {

string::String stringFrom ( const alphabet::Symbol & symbol ) {
	return string::String { string::LinearString < > { std::vector < alphabet::Symbol > { symbol } } };
}

string::String stringFrom ( const std::string & string ) {
	return string::String { string::LinearString < > { string } };
}

string::String stringFrom ( const char * string ) {
	return stringFrom ( ( std::string ) string );
}

string::String stringFrom ( const std::vector < alphabet::Symbol > & str ) {
	return string::String { string::LinearString < > { str } };
}

} /* namespace string */

namespace alib {

auto StringDeleter = xmlApi < string::String >::InputContextDeleter ( );
}
