/*
 * SymbolToStringComposer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnciek
 */

#ifndef SYMBOL_TO_STRING_COMPOSER_H_
#define SYMBOL_TO_STRING_COMPOSER_H_

#include <ostream>
#include <core/multipleDispatch.hpp>
#include "alphabet/Symbol.h"
#include "alphabet/SymbolFeatures.h"

namespace alphabet {

/**
 * This class contains methods to print XML representation of string to the output stream.
 */
class SymbolToStringComposer : public std::SingleDispatchFirstStaticParam<SymbolToStringComposer, void, std::ostream&, const SymbolBase &> {
public:
	static void compose(std::ostream& output, const LabeledSymbol& symbol);
	static void compose(std::ostream& output, const BlankSymbol& symbol);
	static void compose(std::ostream& output, const BottomOfTheStackSymbol& symbol);
	static void compose(std::ostream& output, const EndSymbol& symbol);
	static void compose(std::ostream& output, const StartSymbol& symbol);
	static void compose(std::ostream& output, const RankedSymbol& symbol);
	static void compose(std::ostream& output, const BarSymbol& symbol);
	static void compose(std::ostream& output, const VariablesBarSymbol& symbol);
	static void compose(std::ostream& output, const SubtreeWildcardSymbol& symbol);
	static void compose(std::ostream& output, const NonlinearVariableSymbol& symbol);
	static void compose(std::ostream& output, const SymbolPairSymbol& symbol);
	static void compose(std::ostream& output, const SymbolSetSymbol& symbol);
	static void compose(std::ostream& output, const UniqueSymbol& symbol);

	/**
	 * Prints text representation of Symbol to the output stream.
	 * @param string String to print
	 * @param out output stream to which print the String
	 */
	static void compose(std::ostream& output, const Symbol& string);
};

} /* namespace alphabet */

#endif /* SYMBOL_TO_STRING_COMPOSER_H_ */
