/*
 * TreeFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef TREE_FROM_STRING_PARSER_H_
#define TREE_FROM_STRING_PARSER_H_

#include "tree/TreeFeatures.h"
#include "TreeFromStringLexer.h"

#include <set>
#include <tree>
#include <alphabet/Symbol.h>
#include <alphabet/RankedSymbol.h>

namespace alib {

template < typename T >
struct stringApi;

} /* namespace alib */

namespace tree {

class TreeFromStringParser {
public:
	TreeFromStringParser ( ) { }

private:
	std::tree < alphabet::RankedSymbol > parseRankedContent ( std::istream &, bool &, std::set < alphabet::RankedSymbol > & ) const;
	std::tree < alphabet::Symbol > parseUnrankedContent ( std::istream &, bool &, std::set < alphabet::Symbol > & ) const;

	TreeFromStringLexer m_TreeLexer;

	tree::Tree parseTree ( std::istream & ) const;
	tree::Tree parseTree ( std::istream &, const std::set < FEATURES > & features ) const;

	template < typename T >
	friend struct alib::stringApi;
};

} /* namespace tree */

#endif /* TREE_FROM_STRING_PARSER_H_ */
